Subject: bug#25706: 26.0.50; Slow C file fontification

From: Eli Zaretskii <[email-masked]>
Date: Mon, 30 Nov 2020 18:27:19 +0200

> From: Mattias Engdegård <[email-masked]>
> Date: Mon, 30 Nov 2020 13:46:30 +0100
> Cc: Alan Mackenzie <[email-masked]>, Lars Ingebrigtsen <[email-masked]>
> 
> >> https://raw.githubusercontent.com/qca/qcamain_open_hal_public/master/hal/ar9300/osprey_reg_map_macro.h
> > 
> > I tried reproducing this on a pretty new laptop, and opening the file in
> > question (with your settings) took less than a second with Emacs 28.
> 
> My lappy is less new but not really that slow -- compared to the hardware of the original reporter it's a speed demon --
> but opening the file takes almost 4 s here. More importantly, scrolling through the file is painfully slow.
> 
> The code in the file is nothing out of the ordinary; it consists of macros that are 1-3 lines each; definitely not a pathological case. The entire fontification takes 64 s for this file.
> 
> I'd say the complaint is warranted, even if the original reporter is no longer reachable. Reopen?
> 
> Alan, do you have a diagnose?

I suggest to run this under "M-x profiler-start" and post the fully
expanded profile you get from that.  Bonus points for doing that after
loading the CC Mode files as .el (not .elc), which will make the
profile more detailed.